Name:       dotnet-launcher
Summary:    Launchpad plugin for dotnet apps
Version:    1.1.0
Release:    1
Group:      Application Framework/Application State Management
License:    Apache-2.0
Source0:    %{name}-%{version}.tar.gz
AutoReqProv: no

BuildRequires: cmake
BuildRequires: pkgconfig(aul)
BuildRequires: pkgconfig(bundle)
BuildRequires: pkgconfig(dlog)
BuildRequires: pkgconfig(ecore)
BuildRequires: pkgconfig(launchpad)
BuildRequires: pkgconfig(pkgmgr-info)
BuildRequires: pkgconfig(pkgmgr-installer)
BuildRequires: pkgconfig(elementary)
BuildRequires: pkgconfig(glib-2.0)
BuildRequires: aul-devel
BuildRequires: dotnet-build-tools

%if 0%{?asan_enabled}
BuildRequires: clang >= 3.8
BuildRequires: compiler-rt
%endif

Requires: aul
Requires: launchpad

Requires(post): /sbin/ldconfig
Requires(post): /usr/bin/systemctl
Requires(postun): /sbin/ldconfig
Requires(postun): /usr/bin/systemctl
Requires(preun): /usr/bin/systemctl

%define _loaderdir %{_prefix}/share/aul
%define _configdir /etc
%define _device_api_dir %{dotnet_assembly_path}
%define _runtime_dir /usr/share/dotnet/shared/Microsoft.NETCore.App/2.0.0
%define _install_plugin_dir /usr/etc/package-manager/parserlib
%define _install_mdplugin_dir /etc/package-manager/parserlib/metadata
%define _native_lib_dir /usr/share/dotnet.tizen/lib

ExcludeArch: aarch64

%description
Launchpad plugin for launching dotnet apps


%prep
%setup -q

%define use_managed_launcher 0
%if %{use_managed_launcher}
	%define USE_MANAGED_LAUNCHER ENABLE
%endif

%build

%if 0%{?asan_enabled}
%define _dotnet_build_conf Debug
export CFLAGS=" --target=%{_host} "
export CXXFLAGS=" --target=%{_host} "
%ifarch %{ix86}
export CFLAGS=$(echo $CFLAGS | sed -e 's/--target=i686/--target=i586/')
export CXXFLAGS=$(echo $CXXFLAGS | sed -e 's/--target=i686/--target=i586/')
%endif
%endif

cmake \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
%if 0%{?asan_enabled}
	-DCMAKE_C_COMPILER=clang \
	-DCMAKE_CXX_COMPILER=clang++ \
	-DASAN_ENABLED=TRUE \
%endif
	-DPACKAGE_NAME=%{name} \
	-DLIBDIR=%{_libdir} \
	-DBINDIR=%{_bindir} \
	-DLOADERDIR=%{_loaderdir} \
	-DCONFIGDIR=%{_configdir} \
	-DCMAKE_BUILD_TYPE=%{_dotnet_build_conf} \
	-DDEVICE_API_DIR=%{_device_api_dir} \
	-DRUNTIME_DIR=%{_runtime_dir} \
	-DCROSSGEN_PATH=%{_device_api_dir}/crossgen \
%if %{use_managed_launcher}
	-DCORECLR_LAUNCHER_ASSEMBLY_PATH=%{_bindir}/Tizen.Runtime.dll \
%endif
	-DINSTALL_PLUGIN_DIR=%{_install_plugin_dir} \
	-DINSTALL_MDPLUGIN_DIR=%{_install_mdplugin_dir} \
	-DVERSION=%{version} \
	-DUSE_MANAGED_LAUNCHER=%{?USE_MANAGED_LAUNCHER:%USE_MANAGED_LAUNCHER} \
	-DNATIVE_LIB_DIR=%{_native_lib_dir} \
	NativeLauncher

make %{?jobs:-j%jobs} VERBOSE=1

%dotnet_build Tizen.Runtime

%install
rm -rf %{buildroot}
%make_install
%if %{use_managed_launcher}
install -p -m 644 Tizen.Runtime/bin/*/*/Tizen.Runtime.dll %{buildroot}%{_bindir}
%endif

mkdir -p %{buildroot}%{_native_lib_dir}
ln -sf %{_libdir}/libsqlite3.so.0 %{buildroot}%{_native_lib_dir}/libsqlite3.so

%files
%manifest dotnet-launcher.manifest
%{_loaderdir}/dotnet.loader
%{_loaderdir}/dotnet.launcher
%{_loaderdir}/dotnet.debugger
%{_native_lib_dir}/libsqlite3.so
%{_bindir}/nitool
#%{_install_plugin_dir}/libui-application.so
%{_install_mdplugin_dir}/libprefer_dotnet_aot_plugin.so
%if %{use_managed_launcher}
%{_bindir}/Tizen.Runtime.dll
%endif
%{_bindir}/dotnet-launcher

